unit comment;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, DbCtrls,
  StdCtrls, Buttons, ExtCtrls, DBExtCtrls, db, sqldb;

type

  { TfrmComment }

  TfrmComment = class(TForm)
    btnSave: TBitBtn;
    btnCancel: TBitBtn;
    chkDone: TDBCheckBox;
    dbeTask: TDBEdit;
    memDetail: TDBMemo;
    dbpDue: TDBDateEdit;
    dbpEntered: TDBDateEdit;
    dbmNote: TDBMemo;
    lblDetail: TLabel;
    lblTask: TLabel;
    lblDue: TLabel;
    lblEntered: TLabel;
    lblNote: TLabel;
    pnlComment: TPanel;
    pnlTodo: TPanel;
    procedure btnCancelClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure chkDoneChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormSetUp(AControl: TControl);
    procedure SaveInfo(ADataset: TSQLQuery);
    function Validation(): boolean;
  private
    { private declarations }
  public
    { public declarations }
    constructor create(AControl: TControl); overload;
  end;

var
  frmComment: TfrmComment;

implementation

{$R *.lfm}

uses gdlmod, mainmod;
{ TfrmComment }


procedure TfrmComment.FormCreate(Sender: TObject);
begin

end;

procedure TfrmComment.btnSaveClick(Sender: TObject);
var MyCloseAction :TCloseAction;
begin
  if pnlComment.Visible then
  begin
    if Validation then
      SaveInfo(dmGuidance.qryFacCom)
    else
    begin
      ShowMessage('Ensure the date and comment has been completed');
      ModalResult:=mrNone;
    end;
  end
  else
  begin
    if Validation then
      SaveInfo(dmGuidance.qryTodo)
    else
    begin
      ShowMessage('Ensure Task and Due date has been completed');
      ModalResult:= mrNone;
    end;
  end;
end;

procedure TfrmComment.chkDoneChange(Sender: TObject);
begin
  if chkDone.State = cbChecked then
    dmGuidance.qryTodo.FieldByName('DateComplete').AsDateTime:=date
  else
    dmGuidance.qryTodo.FieldByName('DateComplete').Value:= null;
end;

procedure TfrmComment.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  try
//    btnCancelClick(Sender);
    if CloseAction = Forms.caNone then
    showmessage ('nontingin');
  finally
//    CloseAction :=caFree;
  end;
end;

procedure TfrmComment.btnCancelClick(Sender: TObject);
begin
  if pnlComment.Visible then
  begin
    dmMain.trnMain.Rollback;
    dmGuidance.qryFacCom.Active:=False;
//    dmGuidance.ActivateDatasets();
  end
  else
  begin
    dmMain.trnMain.Rollback;
    dmGuidance.qryTodo.Active:=False;
//    dmGuidance.ActivateDatasets();
  end;
end;

procedure TfrmComment.FormSetUp(AControl: TControl);
begin
  Case UpCase (AControl.Name) of
    'BTNADDCOMMENT', 'BTNEDITCOMMENT':
     begin
       Self.Caption:='Comment';
       pnlTodo.Hide;
       pnlComment.Show;

     end;
    'BTNADDTODO', 'BTNEDITTODO':
    begin
       Self.Caption :='Todo';
       pnlComment.Hide;
       pnlTodo.Show;
     end;
  end;
end;

procedure TfrmComment.SaveInfo(ADataset: TSQLQuery);
begin
  if ADataset.State in [dsInsert, dsEdit] then
  try
    begin
      ADataset.ApplyUpdates();
      dmMain.trnMain.Commit;
    end;
  finally
//    dmGuidance.ActivateDatasets();
  end;
end;

function TfrmComment.Validation: boolean;
begin
  if pnlComment.Visible then
  begin
    if (dbpEntered.Text ='' ) or (dbmNote.Text ='') then
      Result :=False
    else
      Result :=True;
  end
  else
  begin
    if (dbeTask.Text = '') or (dbpDue.Text = '')  then
      Result :=False
    else
      Result :=True;
  end;
end;

constructor TfrmComment.create(AControl: TControl);
begin
  inherited Create(Owner);
  try
    case UpCase(AControl.Name) of
(*      'BTNADDCOMMENT' :
      begin
        FormSetUp(AControl);
        dmGuidance.qryFacCom.Insert;
        dmGuidance.qryFacCom.FieldByName('ComId').Required:=False;
        dmGuidance.qryFacCom.FieldByName('GdlId').AsInteger:=
/           dmGuidance.qryguidance.FieldByName('GdlId').AsInteger;
        dmGuidance.qryFacCom.FieldByName('ComDate').AsDateTime:= Date();
      end; *)
      'BTNEDITCOMMENT':
       begin
         FormSetUp(AControl);
       end;
(*      'BTNADDTODO':
       begin
         FormSetUp(AControl);
         dmGuidance.qryTodo.Insert;
         dmGuidance.qryTodo.FieldByName('Tdlid').Required:=False;
         dmGuidance.qryTodo.FieldByName('DateCreate').AsDateTime:= Date();
         dmGuidance.qryTodo.FieldByName('GdlId').AsInteger:=
            dmGuidance.qryguidance.FieldByName('GdlId').AsInteger;
       end; *)
      'BTNEDITTODO':
       begin
         FormSetUp(AControl);
       end;

    else
      ShowMessage(AControl.ClassName);
    end;
  finally
  end;
end;

end.

